local love = require("love")
require("source.player")
require("assets.data.maps")

loadedmap = testmap

function love.load()

    Camera = require "libs.hump.camera"
    wf = require 'libs/windfield/windfield'

    world = wf.newWorld(0, 0)
    world:setGravity(0, 0)

    camera = Camera()

    playercollider = world:newBSGRectangleCollider(300, 270, 60, 60, 10)
    playercollider:setFixedRotation(true)

    tileImage = love.graphics.newImage("assets/images/tiles/tiles.png")


    tileQuads = {
        greenQuad = love.graphics.newQuad(0, 0, 32, 32, tileImage),
        stoneQuad = love.graphics.newQuad(32, 0, 32, 32, tileImage),
        dirtQuad  = love.graphics.newQuad(0, 32, 32, 32, tileImage)
    }

    love.graphics.setDefaultFilter("nearest", "nearest")
    love.window.setTitle('RPGgame')

    player.load()
    -- player loads
end

function love.update(dt)
    camera:lookAt(player.x, player.y)


    if love.keyboard.isDown("w") then
        player.vy = player.speed * -1
    elseif love.keyboard.isDown("s") then
        player.vy = player.speed
    else
        player.vy = 0
    end

    if love.keyboard.isDown("a") then
        player.vx = player.speed * -1
    elseif love.keyboard.isDown("d") then
        player.vx = player.speed
    else
        player.vx = 0 
    end

    playercollider:setLinearVelocity(player.vx, player.vy)


    world:update(dt)
    player.x = playercollider:getX()
    player.y = playercollider:getY()
    player.update(dt)

end


function love.draw()
    camera:attach()

        for y=1, #loadedmap do
            for x=1, #loadedmap[y] do
                if loadedmap[y][x] == 1 then
                    love.graphics.draw(tileImage, tileQuads.greenQuad, x * 31.9999999999999, y * 31.9999999999999)
                end

                if loadedmap[y][x] == 2 then
                    love.graphics.draw(tileImage, tileQuads.stoneQuad, x * 31.9999999999999, y * 31.9999999999999)
                end

                if loadedmap[y][x] == 3 then
                    
                    --local box = world:newRectangleCollider(x * 31.9999999999999, y * 31.9999999999999)
                    love.graphics.draw(tileImage, tileQuads.dirtQuad, x * 31.9999999999999, y * 31.9999999999999)
                    --box:setFixedRotation(true)
                    --box:setType('static')
                
                end
            end
        end

        player.draw()
    camera:detach()
    love.graphics.print("0", 30, 30)
    
end
